//
//  HomePresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/5/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import Action
import RxSwift
import RxCocoa

protocol HomeWireframeInterface: WireframeInterface {
    func attachPlugin(_ plugin: HomeSectionPlugin)
}

protocol HomeViewInterface: ViewInterface {
    func addSectionViewController(_ viewController: UIViewController)
    func removeSectionViewController(_ viewController: UIViewController)
}

final class HomePresenter: HomePresenterInterface {
    
    // MARK: - Private properties -
    
    private unowned let view: HomeViewInterface
    private let interactor: HomeInteractorInterface
    private let wireframe: HomeWireframeInterface
    
    lazy var getPluginsAction = makeGetPluginAction()
    
    private let disposeBag = DisposeBag()
    
    // MARK: - Lifecycle -
    
    init(view: HomeViewInterface, interactor: HomeInteractorInterface, wireframe: HomeWireframeInterface) {
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
    }
}

// MARK: - Extensions -

extension HomePresenter {
    
    func viewDidLoad() {
        configurePresenter()
    }
    func configurePresenter() {
        
        getPluginsAction
            .elements
            .subscribeNext { [weak self] plugins in
                plugins.forEach {
                    self?.wireframe.attachPlugin($0)
                }
            }
            .disposed(by: disposeBag)
        getPluginsAction.execute()
    }
}

extension HomePresenter {
    func makeGetPluginAction() -> Action<Void, [HomeSectionPlugin]> {
        return Action<Void, [HomeSectionPlugin]> { [unowned self] in
            return interactor.getPlugins()
        }
    }
}

extension HomePresenter: HomeSectionPluginListener {
    func showPlugin(_ plugin: HomeSectionPlugin) {
        
    }
    
    func hidePlugin(_ plugin: HomeSectionPlugin) {
        
    }
    
    func detachPlugin(_ plugin: HomeSectionPlugin) {
        
    }
    
    func reloadPlugin(_ plugin: HomeSectionPlugin) {
        
    }
    
    
}
